# cta.py

# tuples, dicts, classes, dataclasses, namedtuples

# Which one of those would provide the most efficient representation?
# Timed: 15-20 minutes.

def read_bus_data(filename, make_record):
    records = [ ]
    with open(filename) as file:
        headers = next(file)
        for line in file:
            parts = line.split(',')
            route = parts[0]
            date = parts[1]
            daytype = parts[2]
            rides = int(parts[3])
            record = make_record(route, date, daytype, rides)
            records.append(record)
    return records

def make_tuple(route, date, daytype, rides):    # 157MB
    return (route, date, daytype, rides)

def make_dict(route, date, daytype, rides):     # 275MB
    return { 'route': route, 'date': date, 'daytype': daytype, 'rides':rides }

class Record:
    __slots__ = ('route', 'date', 'daytype', 'rides')
    def __init__(self, route, date, daytype, rides): # 216MB.  151MB with slots
        self.route = route
        self.date = date
        self.daytype = daytype
        self.rides = rides
        
# How much memory is required to store the data???  How would you find out?
import tracemalloc
tracemalloc.start()
records = read_bus_data('ctabus.csv', Record)
print(tracemalloc.get_traced_memory())
