# portfolio.py
#
# Read the file "portfolio.csv" into a Python data structure

def read_portfolio(filename):
    records = [ ]
    with open(filename) as file:
        # The first line of the file is headers.   We'll skip those
        next(file)
        for line in file:
            parts = line.split(',')
            name = parts[0][1:-1]
            shares = int(parts[1])
            price = float(parts[2])
            record = make_record(name, shares, price)
            records.append(record)
    return records

# Question:  What is make_record?  Do you make a tuple?  A dict? A class?
# Named tuple?  Later thought:  What is the most efficient?
def make_record(name, shares, price):
    return {'name': name, 'shares': shares, 'price': price} # Dict

portfolio = read_portfolio('portfolio.csv')
